var userInfo,
    zipDir = '',
    prepare = '';

var ChannelList = function() {
    var self = this;
    this.id = '';
    this.data = null;
    this.channelData = null;
    this.$container = $('#level2');
    this.$contentContainer = this.$container.find('.navItem');
    this.$itemState = this.$container.find('.itemState');
    this.$contentContainer.delegate('dl', 'click', function() {
        self.id = $(this).attr('data');
        var channelData = self.data[self.id];
        self.channelData = channelData;
        articleList.setData('id', self.id);
        var articleData = downloadData.getData('articleData');
        if (articleData) {
            articleList.init();
        } else {
            prepare = 'article';
        }
    });
    this.$contentContainer.delegate('.delete', 'click', function(e) {
        e.stopPropagation();
        if (confirm('是否删除该频道下的所有听力文章？')) {
            if (self.$contentContainer.find('.special').length == 1) {
                Qt.gotoOnline();
                WebApi.saveData('downloadState', 'no');
            }
            ui.pushMessage('当前听力频道已删除');
            var channelId = $(this).parent().attr('data'),
                channelData = downloadData.getData('channelData'),
                articleData = downloadData.getData('articleData');
            delete channelData[channelId];
            downloadData.setData('channelData', channelData);
            delete articleData[channelId];
            downloadData.setData('articleData', articleData);
            $(this).parent().remove();
            downloadData.deleteChannelData(channelId);
            Qt.deleteChannelData(channelId);
        }
    });
};
ChannelList.prototype.setData = function(key, value) {
    this[key] = value;
};
ChannelList.prototype.getData = function(key) {
    return this[key];
};
ChannelList.prototype.init = function() {
    this.reset();
    articleList.reset();
    this.$container.show();
    var data, title, img, index, downloadCount;
    var datas = downloadData.getData('channelData');
    this.data = datas;
    if (datas) {
        for (var channelId in datas) {
            data = datas[channelId];
            title = Mapping.convert(data, 'title');
            img = Mapping.convert(data, 'thumbImg');
            index = img.indexOf('MediaPool');
            img = zipDir + img.substring(index + 10);
            downloadCount = Mapping.convert(data, 'downloadCount');
            $('<dl class="special" data="' + channelId + '"><dt class="sp-title">' + title +
                '</dt><dd class="sp-image"><img src="' + img +
                '" alt="' + title +
                '" /></dd><dd class="sp-relative"><span class="spr-times">' + downloadCount +
                '</span><span class="spr-date">' + data['create_time'].split('T')[0] +
                '</span></dd><dd class="delete"></dd></dl>').appendTo(this.$contentContainer);
        }
        this.$itemState.hide();
    }
};
ChannelList.prototype.reset = function() {
    this.$itemState.show();
    this.$contentContainer.text('');
    this.$container.hide();
};
ChannelList.prototype.deleteChannelData = function(channelId) {
    this.init();
    if (this.$contentContainer.find('.special').length == 0) {
        Qt.gotoOnline();
        WebApi.saveData('downloadState', 'no');
    }
    Qt.deleteChannelData(channelId);
};
var channelList = new ChannelList();

var ArticleList = function() {
    var self = this;
    this.id = '';
    this.data = [];
    this.articleIndex = {};
    this.exportState = false;
    this.$export = $('#export');
    this.$container = $('#level3');
    this.$title = this.$container.find('.sn-titleBar');
    this.articleTitle = '';
    this.$channelInfo = this.$container.find('.channelInfo');
    this.$itemState = this.$container.find('.itemState');
    this.$contentContainer = this.$container.find('.navItem');
    this.$container.click(function() {
        self.resetExport();
    }).delegate('dl', 'click', function() {
        if (!$(this).hasClass('downloading')) {
            var index = $(this).index();
            var articleData = self.data[index];
            article.setData('index', index);
            article.setData('id', articleData['uuid']);
            $('.sp-title.cur').removeClass('cur');
            article.init($(this).find('.sp-title'));
        }
    }).delegate('dl', 'mousedown', function(e) {
        if (e.which == 3) {
            self.articleTitle = $(this).find('.sp-title').text();
            self.src = zipDir + $(this).attr('data') + '.rar';
            self.exportState = true;
        }
    }).delegate('dl', 'mouseup', function(e) {
        if (self.exportState) {
            self.$export.css({
                'left': e.clientX + 'px',
                'top': e.clientY - 80 + 'px'
            });
            self.$export.show();
        }
    });
    this.$export.click(function(e) {
        e.stopPropagation();
        if ($(this).hasClass('enable')) {
            self.articleTitle = self.articleTitle.replace(/\//g, '-');
            Qt.saveExportFile(resetZipDir(self.src), self.articleTitle + '.mp3');
            self.resetExport();
        }
    });
    this.$container.delegate('.delete', 'click', function(e) {
        e.stopPropagation();
        if (confirm('是否删除该篇听力文章？')) {
            var channelId = 'hasContent',
                articleId = $(this).parent().attr('data');
            self.updateArticleIndex(articleId);
            var channelId = self.id,
                articleDatas = downloadData.getData('articleData'),
                articleData = articleDatas[channelId],
                tempArticle;
            for (var i = 0, l = articleData.length; i < l; i++) {
                tempArticle = articleData[i];
                if (tempArticle['uuid'] == articleId) {
                    articleData.splice(i, 1);
                    break;
                }
            }
            articleDatas[channelId] = articleData;
            downloadData.setData('articleData', articleDatas);
            var playId = article.getData('id');
            if (playId && playId == articleId) {
                article.removeContent();
                Qt.resetMedia();
            }
            if (self.$contentContainer.find('.special').length == 1) {
                channelId = self.id;
            }
            ui.pushMessage('当前听力文章已删除');
            Qt.deleteArticleData(articleId, channelId);
            downloadData.deleteArticleData(articleId, self.id);
            $(this).parent().remove();
            //if (channelId != 'hasContent') {
            // self.reset();
            // channelList.init();
            //}
        }
    });
    this.$title.click(function() {
        self.reset();
        channelList.init();
    });
};
ArticleList.prototype.setExportEnable = function(enable) {
    this.$export.attr('class', enable);
};
ArticleList.prototype.resetExport = function() {
    this.exportState = false;
    this.$export.hide();
};
ArticleList.prototype.setData = function(key, value) {
    this[key] = value;
};
ArticleList.prototype.getData = function(key) {
    return this[key];
};
ArticleList.prototype.init = function() {
    channelList.reset();
    this.reset();
    var channelData = channelList.getData('channelData');
    if (channelData == null) {
        var channelDatas = downloadData.getData('channelData');
        for (var i in channelDatas) {
            if (i == this.id) {
                channelData = channelDatas[i];
                break;
            }
        }
    }
    var channelName = channelData['name'];
    if (!channelName) {
        channelName = channelData['title'];
    }
    this.$title.find('h3').find('span').eq(0).text(channelName);
    this.$channelInfo.find('.desc').text(channelData['description']);
    this.$channelInfo.find('.spr-times').text(Mapping.convert(channelData, 'downloadCount'));
    this.$channelInfo.find('.spr-date').text(channelData['create_time'].split('T')[0]);
    this.$container.show();
    var img, createTime, downloadCount, index, articleId, channelId = this.id,
        data, downloadState, datas = downloadData.getData('articleData')[channelId];
    this.data = datas;
    this.articleIndex = [];
    if (datas) {
        for (var i = 0, l = datas.length; i < l; i++) {
            data = datas[i];
            this.articleIndex[articleId] = i;
            articleId = data['uuid'];
            img = Mapping.convert(data, 'thumbImg');
            createTime = Mapping.convert(data, 'createTime');
            downloadCount = Mapping.convert(data, 'downloadCount');
            index = img.indexOf('MediaPool');
            img = zipDir + img.substring(index + 10);
            downloadState = data['downloadState'];
            $('<dl class="special ' + downloadState + '" data="' + articleId + '"><dt class="sp-title">' + data['title'] +
                '</dd><dd class="sp-image"><img src="' + img +
                '" alt="' + data['title'] +
                '" /></dd><dd class="sp-relative"><span class="spr-times">' + downloadCount +
                '</span><span class="spr-date">' + createTime.split('T')[0] +
                '</span></dd><dd class="delete"></dd></dl>').appendTo(this.$contentContainer);
        }
        this.$itemState.hide();
    }
};
ArticleList.prototype.reset = function() {
    this.$itemState.show();
    this.$contentContainer.text('');
    this.$container.hide();
};
ArticleList.prototype.updateDownloadingProgress = function(totalRatio, articleId) {
    var index = this.articleIndex[articleId];
    if (index) {
        var $nodeList = this.$contentContainer.find('dl');
        $nodeList.eq(index).find('.delete').text(totalRatio);
    }
};
ArticleList.prototype.setDownloadFinished = function(articleId) {
    var index = this.articleIndex[articleId];
    if (index) {
        var $node = this.$contentContainer.find('dl').eq(index);
        $node.attr('class', 'special downloaded');
        $node.find('.delete').text('');
    }
    var channelId = this.id,
        articleData = downloadData.getData('articleData')[channelId],
        article;
    if (articleData) {
        for (var i = 0, l = articleData.length; i < l; i++) {
            article = articleData[i];
            if (article['uuid'] == articleId) {
                article['downloadState'] = 'downloaded';
                break;
            }
        }
    }
};
ArticleList.prototype.updateArticleIndex = function(articleId) {
    articleIndex = this.articleIndex;
    var index = articleIndex[articleId],
        key, value;
    for (key in articleIndex) {
        value = articleIndex[key];
        if (value > index) {
            value = value - 1;
            articleIndex[key] = value;
        }
    }
    delete articleIndex[articleId];
    this.articleIndex = articleIndex;
};
var articleList = new ArticleList();

var Article = function() {
    this.id = '';
    this.$tempData = $('#tempData');
    this.src = '';
    this.index = 0;
    this.escapeTop = 0;
    this.translationState = Tools.getLocalStorage('translationState');
    this.explainState = Tools.getLocalStorage('explainState');
    this.explain = null;
    this.firstWords = 0;
    this.wordsArr = [];
    this.firstArray = [];
    this.$choised = $('.choised');
    this.choisedIndex = 0;
    this.choisedItem = 9;
    this.$fillwordEscape = [];
    this.choisedState = true;
    this.title = '';
};
Article.prototype.setData = function(key, value) {
    this[key] = value;
};
Article.prototype.getData = function(key) {
    return this[key];
};
Article.prototype.removeContent = function() {
    $('.article .contents, .article .contentInfo').hide();
    $('.article .itemState').show();
};
Article.prototype.init = function($spTitle) {
    $('.dictArea').html('<p class="origin"></p><div class="translation"></div>');
    media.detectDesktopStateSeted(true);
    $('.sp-title.cur').removeClass('cur');
    $spTitle.addClass('cur');
    this.src = zipDir + this.id + '.rar';
    var self = this,
        articleContent = WebApi.getFileContent(this.id, 'article'),
        lrc = WebApi.getFileContent(this.id, 'lrc');
    if (articleContent != 'error') {
        var data = articleContent.match(/<body>(\s*.+)*/)[0].replace(/<body>/, '').replace(/<\/body>\s*<\/html>/, '');
        var content = document.createElement('div');
        content.innerHTML = data;
        var $title = $(content).find('h1').text();
        this.title = $title;
        if ($(content).find('.img-border').length > 0) {
            var imgSrc = zipDir + 'articleContent/' + $(content).find('.img-border img').attr('src');
            $(content).find('.img-border img').attr('src', '');
            $('.contentInfo img, .playInfo .playContent img').attr('src', imgSrc).attr('alt', $title);
            $('.contentInfo img, .playInfo .playContent img').show();
            $('.playInfo').removeClass('noImage');
        } else {
            $('.contentInfo img, .playInfo .playContent img').hide();
            $('.playInfo').addClass('noImage');
        }
        $('.contentInfo .title, .playInfo .playContent .title').text($title);
        $('.playInfo .playContent .title').attr('title', $title);
        $('.contents .wrap').html($(content).find('#article p')).append($(content).find('input')).append($(content).find('.copyright'));
        $('.article .itemState').hide();
        $('.contentInfo, .contents').show();
        $('.article .playInfo').addClass('noTranslate');
        Qt.saveData('hasTranslation', false);
        media.setTranslationState(this.translationState);
        if (lrc && lrc != 'error') {
            this.insertLrc(lrc);
        }
        this.$tempData.html($('.contents .wrap').html());
        $('.wrap').html($('.wrap').html().replace(/<w>/g, '').replace(/<\/w>/g, '').replace(/<d>/g, '').replace(/<\/d>/g, ''));
        this.initHtmlData();
        this.captureWord();
        this.escapeTop = $('.wrap').offset().top;
        media.initPlay(this.src, 'local');
        slideNav.slideOut();
        this.prepareSentence();
        var mode = media.getData('modeState').split(',')[0];
        this.setMode(mode);
        this.choisedState = true;
        this.$choised.unbind('click').bind('click', function(e) {
            var $target = $(e.target);
            if ($target.hasClass('cword')) {
                self.choisedAction($target);
            }
        });
    }
};
Article.prototype.insertLrc = function(lrc) {
    lrc = JSON.parse(lrc);
    if (lrc['wordstate'] == 'yes') {
        this.explain = lrc['words'];
        this.setExplain(this.explainState);
    }
    var isvip = userInfo['isvip'],
        maxRead = userInfo['maxRead'],
        isOverRead = userInfo['isOverRead'],
        readedTime = userInfo['readedTime'];
    if (!isvip) {
        this.hideExplain();
        if (!isOverRead) {
            if (readedTime <= maxRead) {
                readedTime++;
                userInfo['readedTime'] = readedTime;
                if (readedTime >= maxRead) {
                    isOverRead = true;
                    userInfo['isOverRead'] = isOverRead;
                    userInfo['maxRead'] = maxRead;
                }
                Tools.setLocalStorage('userInfo', userInfo);
            }
        } else {
            lrc = 'buy';
        }
    }
    if (lrc != 'buy') {
        if ('state' in lrc) {
            if (lrc['state'] == 'yes') {
                Qt.saveData('hasTranslation', true);
                $('.article .playInfo').removeClass('noTranslate');
                lrc = lrc['list'];
                var item = 0;
                $('.paragraph').each(function(index) {
                    if (lrc[item] && lrc[item]['order'] == index + 1) {
                        $('<div class="lrc prev"><p class="chinese" data="' + lrc[item]['hashvalue'] + '">' + lrc[item]['text'] +
                            '</p><span class="displayTip" onclick="article.displayTip(this);">点击显示译文</span></div>').insertAfter($(this)[0]);
                        item++;
                    }
                });
                $('.article').removeClass('hideLrc');
            }
        }
        if ('has_translation' in lrc) {
            if (lrc['has_translation']) {
                Qt.saveData('hasTranslation', true);
                $('.article .playInfo').removeClass('noTranslate');
                (function insert(lrcContent) {
                    var orderIndex = -1,
                        translate, order, timestamp, hashvalue, text, trans;
                    for (var i = 0, l = lrcContent.length; i < l; i++) {
                        translate = lrcContent[i];
                        order = translate['order'];
                        order -= 1;
                        timestamp = translate['timestamp'];
                        text = translate['text'];
                        hashvalue = translate['hashvalue'];
                        if (order != orderIndex) {
                            if (orderIndex != -1) {
                                trans += '</p><span class="displayTip" onclick="article.displayTip(this);">点击显示译文</span></div>';
                                $(trans).insertAfter($('.paragraph').eq(order - 1));
                            }
                            trans = '<div class="lrc"><p class="chinese"><span class="segment" id="S_' + timestamp + '" data="' + hashvalue + '">' + text + '</span>';
                        } else {
                            trans += '<span class="segment" id="S_' + timestamp + '" data="' + hashvalue + '">' + text + '</span>';
                        }
                        orderIndex = order;
                    }
                    trans += '</p><span class="displayTip">点击显示译文</span></div>';
                    $(trans).insertAfter($('.paragraph').eq(order));
                    $('.article').removeClass('hideLrc');
                }(lrc['translation']));
            }
        }
    } else {
        $('.paragraph').each(function() {
            $('<div class="lrc"><p class="chinese" onclick="article.preventVip();">翻译功能已禁用，点击开启VIP权限</p></div>').insertAfter($(this)[0]);
        });
    }
    this.setLrc(this.translationState);
    this.initHtmlData();
};
Article.prototype.initHtmlData = function() {
    var title = $('.contentInfo .title').text(),
        page = '<div class="titleArea"><p class="title">' + title + '</p>' +
        '<p class="specialtitle">' + $('.contentInfo .specialtitle').text() + '</p></div>' +
        '<div class="content">' + $('.wrap').html() + '</div>';
    var htmlPage = '<!doctype html>' +
        '<html>' +
        '<head>' +
        '<meta charset="utf-8">' +
        '<title>' + title + '</title>' +
        '<style type="text/css">' +
        'html, body, p{margin:0; padding:0;}' +
        'body{font-size:11pt; padding:30px 50px;}' +
        '.titleArea, .chinese{font-family: "微软雅黑", "黑体", sans-serif;}' +
        '.titleArea{margin-bottom:30px;}' +
        '.title{font-size:12pt;}' +
        '.content{margin-top:30px;}' +
        '.specialtitle{font-size:10pt;}' +
        '.paragraph{margin-top:10px; margin-bottom:5px;}' +
        '.chinese{font-size:10pt; color:rgb(71, 71, 71); line-height:11pt;}' +
        '.copyright{margin-top:20px;}' +
        '#J_CIKU_sentence_time_range, .displayTip{color:transparent;height:0;line-height:0;font-size:0;}' +
        '</style>' +
        '</head>' +
        '<body>';
    htmlPage += page;
    htmlPage += '</body></html>';
    Qt.setHtmlPage(htmlPage, title);
};
Article.prototype.setLrc = function(state) {
    var translateState;
    this.translationState = state;
    Tools.setLocalStorage('translationState', state);
    switch (state) {
        case 'on':
            $('.article').removeClass('hideLrc');
            $('.article, .translation').removeClass('showTip');
            translateState = 'translateOn,已打开译文';
            break;
        case 'tap':
            $('.article').removeClass('hideLrc');
            $('.article, .translation').addClass('showTip');
            translateState = 'translateTap,点击显示译文';
            break;
        case 'off':
            $('.article').addClass('hideLrc');
            translateState = 'translateOff,已关闭译文';
            break;
    }
    if (window.media) {
        media.setTranslationState(translateState);
    }
    Qt.saveData('translateState', translateState);
};
Article.prototype.setHideDisplayTipIndex = function(index) {
    $('.dictArea .translation').addClass('showTranslation');
    $('.lrc').eq(index).addClass('showTranslation');
}
Article.prototype.hideExplain = function() {
    var documentText = $('.wrap').html();
    documentText = documentText.replace(new RegExp('<span class=(.)transHighlight(.>)(.*?)<\\/span>($|\\s)<span class=(.)trans(.*?)<\\/span>', 'g'), function(m, p1, p2, p3, p4, p5, p6) {
        return p3 + p4;
    });
    $('.wrap').html(documentText);
    this.prepareSentence();
};
Article.prototype.showExplain = function(explain) {
    var documentText = $('.wrap').html(),
        origin, trans;
    for (var i = 0, l = explain.length; i < l; i++) {
        origin = explain[i]['word'];
        trans = explain[i]['exp'];
        documentText = documentText.replace(new RegExp('(^|\\s)' + origin + '($|\\s)', 'g'), function(word, p1, p2) {
            return p1 + '<span class="transHighlight">' + origin + '</span>' + p2 + '<span class="trans"> (' + trans + ') </span>';
        });
    }
    $('.wrap').html(documentText);
    this.prepareSentence();
};
Article.prototype.setExplain = function(state) {
    this.explainState = state;
    Tools.setLocalStorage('explainState', state);
    this.hideExplain();
    if (!this.explain || !this.explain.length) {

    } else {
        var explain = [];
        if (state == 'primary') {
            explain = this.explain[0]['items'].concat(this.explain[1]['items']).concat(this.explain[2]['items']);
        }
        if (state == 'middle') {
            explain = this.explain[1]['items'].concat(this.explain[2]['items']);
        }
        if (state == 'senior') {
            explain = this.explain[2]['items'];
        }
        this.showExplain(explain);
    }
};
Article.prototype.preventVip = function() {
    Qt.openWindow(SoftWare[downloadData.getData('lang')]['purchase']);
};
Article.prototype.displayTip = function(target) {
    var $parent = $(target).parent(),
        chinese = $(target).prev().text(),
        index, $currentLrc;
    $parent.addClass('showTranslation');
    if (/translation/.test($parent.attr('class'))) {
        index = parseInt($parent.attr('index'));
        $currentLrc = $('.sentence').eq(index).parent().next();
        $currentLrc.addClass('showTranslation');
        chinese = chinese.replace(/'/g, "======").replace(/"/g, ";;;;;;");
        Qt.setParagaraph('chinese', '{"chinese":"' + chinese + '", "index":' + index + ', "state":true}');
    }
};
Article.prototype.captureWord = function() {
    var curPosX, curPosY, curCaptured = false,
        maxWordsLeft = 2,
        maxWordsRight = 5;
    var timeout;
    $('.wrap').bind('mouseout', function() {
        clearTimeout(timeout);
    });
    $('.wrap').bind('mousemove', function(e) {
        clearTimeout(timeout);
        curPosX = e.clientX;
        curPosY = e.clientY;
        curCaptured = false;
        timeout = setTimeout(function() {
            tryCapture();
        }, 500);
    });

    function isSeprator(s) {
        var bCn = /[^\u4e00-\u9fa5]/.test(s);
        return (!bCn || s == ' ');
    }

    function tryCapture() {
        if (curCaptured) {
            return;
        }
        var r = document.caretRangeFromPoint(curPosX, curPosY);
        var nodeLength = r.startContainer.length;
        if (!r || !r.startContainer.data || (r.startOffset == 0 && r.endOffset == 0) || r.endOffset == nodeLength) {
            return;
        }
        curCaptured = true;
        var midPos = r.startOffset;
        var startPos = r.startOffset - 1;
        var endPos = r.endOffset;
        var cLeft = cRight = 0;
        var capturedLine = '';

        var textContainer = r.startContainer;
        if (textContainer.nodeType == 3) {
            capturedLine = textContainer.textContent;
        } else {
            capturedLine = textContainer.innerText;
        }
        r.detach();
        for (; startPos >= 0; startPos--) {
            if (isSeprator(capturedLine.substring(startPos, startPos + 1))) {
                cLeft++;
            }
            if (cLeft > maxWordsLeft) {
                break;
            }
        }
        for (; endPos <= nodeLength; endPos++) {
            if (isSeprator(capturedLine.substring(endPos - 1, endPos))) {
                cRight++;
            }
            if (cRight > maxWordsRight) {
                break;
            }
        }
        var requestString = capturedLine.substring(startPos, endPos);
        var requestPostion = (midPos - startPos - 2);
        if ((requestPostion + 3) < requestString.length) {
            var productId = 32071 + SoftWare[downloadData.getData('lang')]['productid'];
            var url = 'http://127.0.0.1:' + productId + '/eudic_capture_word?word=' + requestString + '&curpos=' + requestPostion + '&src=ting_desktop';
            Qt.captureWord(url);
        }
    }
};
Article.prototype.prepareSentence = function() {
    var self = this;
    $('.sentence').hover(function(e) {
        if (!$(this).hasClass('high_light')) {
            $('.playTip').css({
                'top': $(this).offset()['top'] - 122
            }).show();
        }
    }, function() {
        $('.playTip').hide();
    }).click(function() {
        var repeatState = media.getData('repeatState').split(',')[0];
        var playTime = $(this).attr('id').split('_')[1],
            startPosition = media.getTransformTimes(playTime);
        Qt.setLoadPositionState('true');
        Qt.setClickState('true');
        media.play(startPosition, false);
        Qt.setClickState('false');
        self.highlight($(this));
        var index = $('.sentence').index($('.high_light'));
        media.setData('playIndex', index);
        Qt.setPlayIndex(index);
    });
};
Article.prototype.highlight = function(param) {
    if (param) {
        var node;
        if (typeof(param) == 'string') {
            node = document.getElementById('J_' + param);
        } else {
            node = param[0];
        }
        var sentence = $(node).html(),
            $lrc = $(node).parent().next(),
            chinese = $lrc.find('.chinese').text();
        sentence = sentence.replace(/'/g, "======").replace(/"/g, ";;;;;;");
        var state = false,
            index = $('.lrc').index($lrc);
        if ($lrc.hasClass('showTranslation')) {
            state = true;
        }
        Qt.setParagaraph('sentence', sentence);
        chinese = chinese.replace(/'/g, "======").replace(/"/g, ";;;;;;");
        Qt.setParagaraph('chinese', '{"chinese":"' + chinese + '","index":' + index + ',"state":' + state + '}');
        var $highlight = $('.high_light');
        if ($highlight) {
            $highlight.removeClass('high_light');
        }
        node.className = node.className + ' high_light';
        var st = $('.wrap').scrollTop();
        if ($(node).offset()['top'] + $(node).height() - this.escapeTop > $('.wrap').height() || $(node).offset()['top'] - this.escapeTop < 0) {
            $('.wrap').scrollTop(st + $(node).offset()['top'] - this.escapeTop);
        }
    }
};
Article.prototype.setMode = function(modeState) {
    var readAppearance, dictAppearance, fillwordApperance, index = $('.sentence').index($('.high_light'));
    if (index < 0) {
        index = 0;
    }
    switch (modeState) {
        case 'read':
            readAppearance = 'block';
            dictAppearance = 'none';
            fillwordApperance = 'none';
            break;
        case 'dictation':
            dictAppearance = 'block';
            readAppearance = 'none';
            fillwordApperance = 'none';
            this.initIndex(index, 'dictation');
            Qt.setDictationIndex(index);
            break;
        case 'fillword':
            fillwordApperance = 'block';
            readAppearance = 'none';
            dictAppearance = 'none';
            this.initIndex(index, 'fillword');
            Qt.setFillwordIndex(index);
            break;
    }
    $('.wrap').css('display', readAppearance);
    $('.dictArea').css('display', dictAppearance);
    $('.fillwordArea').css('display', fillwordApperance);
};
Article.prototype.initDictation = function(index) {
    this.initIndex(index, 'dictation');
};
Article.prototype.initIndex = function(index, type) {
    var $originArea, $transArea;
    switch (type) {
        case 'dictation':
            $originArea = $('.dictArea .origin');
            $transArea = $('.dictArea .translation');
            break;
        case 'fillword':
            media.setFillwordState(false);
            $originArea = $('.fillwordArea .origin');
            $transArea = $('.fillwordArea .translation');
            break;
    }
    var $sentence = this.$tempData.find('.sentence'),
        $origin = $sentence.eq(index),
        $originLrc = $origin.parent().next();
    if (!$originLrc.hasClass('prev')) {
        var starttime = $origin.attr('data-starttime'),
            origin = $origin.html().replace(new RegExp('<span class=(.)transHighlight(.>)(.*?)<\\/span>($|\\s)<span class=(.)trans(.*?)<\\/span>', 'g'), function(m, p1, p2, p3, p4, p5, p6) {
                return p3 + p4;
            }),
            chinese = $(document.getElementById('S_' + starttime)).html();
        if(!chinese){
            chinese = '';
        }
        $originArea.html(origin);
        if (!/翻译功能已禁用/.test(chinese)) {
            var state = false;
            $transArea.html('<span class="chinese">' + chinese + '</span><span class="displayTip" onclick="article.displayTip(this);">点击显示译文</span>');
            if ($origin.parent().next().hasClass('showTranslation')) {
                $transArea.attr('class', 'translation showTranslation');
                state = true;
            } else {
                $transArea.attr('class', 'translation');
            }
            $transArea.attr('starttime', starttime);
            Qt.setParagaraph('trans', '{"chinese":"' + chinese + '","state":' + state + ',"index":' + index + '}');
        }
    } else {
        origin = $origin.html().replace(new RegExp('<span class=(.)transHighlight(.>)(.*?)<\\/span>($|\\s)<span class=(.)trans(.*?)<\\/span>', 'g'), function(m, p1, p2, p3, p4, p5, p6) {
            return p3 + p4;
        }),
        trans = $originLrc.html(),
        chinese = $originLrc.find('.chinese').text(),
        $dictArea = $('.dictArea .translation, .fillwordArea .translation');
        if(!chinese){
            chinese = '';
        }
        $('.dictArea .origin, .fillwordArea .origin').html(origin);
        if ($originLrc.hasClass('lrc') && trans && !/翻译功能已禁用/.test(trans)) {
            var state;
            $dictArea.html(trans);
            if (/showTranslation/.test($originLrc.attr('class'))) {
                $dictArea.attr('class', 'translation showTranslation');
                state = true;
            } else {
                $dictArea.attr('class', 'translation');
                state = false;
            }
            $dictArea.attr('index', index);
            Qt.setParagaraph('dictTrans', '{"chinese":"' + chinese + '","state":' + state + ',"index":' + index + '}');
        }
    }    
    switch (type) {
        case 'dictation':
            this.setPlayTimes(index, 0);
            break;
        case 'fillword':
            this.setFillword();
            break;
    }
};
Article.prototype.setPlayTimes = function(index, times) {
    var $node = $('.dictArea .origin').find($('w')),
        wsize = $node.size(),
        ssize = parseInt(wsize / 3 * 2),
        wordsIndex = [],
        wordsArr = [],
        flag = true,
        word, isize, roundN, $singleW;
    for (var i = 0; i < wsize; i++) {
        word = $node.eq(i).text();
        wordsIndex.push(i);
        if (word.length > 5) {
            wordsArr.push(i);
        }
    }
    if (wordsArr.length < ssize) {
        flag = false;
    }
    if (flag) {
        wsize = wordsArr.length;
    }
    times = parseInt(times);
    switch (times) {
        case 0:
            isize = parseInt(wsize * 0.3);
            if (isize < 1) {
                isize = 1;
            }
            this.firstWords = isize;
            this.wordsArr = flag ? wordsArr : wordsIndex;
            for (var i = 0; i < isize; i++) {
                roundN = Math.round(Math.random() * wsize);
                $singleW = flag ? $node.eq(wordsArr[roundN]) : $node.eq(roundN);
                $singleW.addClass('fill');
                this.firstArray.push(roundN);
                this.wordsArr.splice(roundN, 1);
            }
            break;
        case 1:
            isize = parseInt(wsize * 0.7);
            if (isize < 2) {
                if (isize < 1) {
                    isize = 1;
                } else {
                    isize = 2;
                }
            }
            if (isize >= this.firstWords) {
                isize = isize - this.firstWords;
            }
            var total = wsize - this.firstWords;
            for (var i = 0; i < isize; i++) {
                roundN = Math.round(Math.random() * total);
                if (flag) {
                    $node.eq(this.wordsArr[roundN]).addClass('fill');
                } else {
                    $node.eq(roundN).addClass('fill');
                }
            }
            for (var i = 0, l = this.firstArray.length; i < l; i++) {
                $node.eq(this.firstArray[i], 'fill');
            }
            break;
        case 2:
        default:
            for (var i = 0, l = $node.length; i < l; i++) {
                $node.eq(i).addClass('fill');
            }
            break;
    }
    var dictation = $('.origin').html();
    dictation = dictation.replace(/'/g, '======').replace(/"/g, ";;;;;;");
    Qt.setParagaraph('dictation', dictation);
};
Article.prototype.setFillword = function() {
    var selectData = {},
        $choiseNode = $('.fillwordArea .origin w');
    this.choisedIndex = 0;
    $choiseNode.attr('class', 'fill');
    var len = $choiseNode.length,
        item = 9,
        wordHtml = '',
        index, $escape;
    if (len < 9) {
        item = len;
    }
    this.choisedItem = item;
    for (var i = 0; i < item; i++) {
        do {
            index = parseInt(Math.random() * len);
        } while (selectData['index' + index] == 'added') {
            selectData['index' + index] = 'added';
        }
    }
    for (var data in selectData) {
        index = data.replace(/index/, '');
        wordHtml += '<span class="cword">' + $choiseNode.eq(index).html() + '</span>';
        $escape = $choiseNode.eq(index);
        $escape.removeClass('fill').addClass('escape');
    }
    Qt.setParagaraph('fillword', '{"text":"' + $('.fillwordArea .origin').html().replace(/'/g, '======').replace(/"/g, ";;;;;;") + '", "item":' + this.choisedItem + '}');
    this.$fillwordEscape = $('.escape');
    this.$choised.html(wordHtml);
    Qt.setParagaraph('choised', wordHtml);
};
Article.prototype.choisedAction = function($target) {
    var choisedWord = $target.text(),
        $correct = this.$fillwordEscape.eq(0),
        correctWord = $correct.text();
    if (choisedWord == correctWord) {
        if (this.choisedState) {
            $correct.addClass('correct');
        } else {
            $correct.addClass('error');
            this.choisedState = true;
        }
        $correct.addClass('fill').removeClass('escape');
        this.$fillwordEscape = $('.escape');
        this.choisedIndex++;
        if (this.choisedIndex == this.choisedItem) {
            $correct.addClass('correct');
            setTimeout(function() {
                Qt.fillwordSuccessAction();
            }, 1000);
        }
    } else {
        this.choisedState = false;
        $target.addClass('animError');
        setTimeout(function() {
            $target.removeClass('animError');
        }, 500);
    }
};
Article.prototype.paragraphFillwordSuccess = function() {
    Qt.fillwordSuccessAction();
};
var article = new Article();

var DownloadData = function() {
    this.articleData = {};
    this.channelData = {};
    this.ratioData = {};
    this.lang = '';
};
DownloadData.prototype.appendData = function(type, data, downloadState) {
    data = JSON.parse(data);
    if (type == 'articleData') {
        data['downloadState'] = downloadState;
        var articleData = this.articleData,
            channelId = data['channel_id'];
        if (!channelId) {
            channelId = data['parent_uuid'];
        }
        if (!articleData[channelId]) {
            articleData[channelId] = [];
        }
        articleData[channelId] = articleData[channelId].concat(data);
        this.articleData = articleData;
    }
    if (type == 'channelData') {
        var channelId = Mapping.convert(data, 'channelId');
        this.channelData[channelId] = data;
    }
};
DownloadData.prototype.getData = function(key) {
    return this[key];
};
DownloadData.prototype.setData = function(key, value) {
    this[key] = value;
};
DownloadData.prototype.deleteArticleData = function(articleId, channelId) {
    var articleData = this.articleData,
        articleChannelDatas = articleData[channelId],
        articleChannelData, index = -1;
    if (articleChannelDatas.length == 0) {
        var channelData = this.channelData;
        delete channelData[channelId];
        this.channelData = channelData;
        delete articleData[channelId];
        this.articleData = articleData;
        channelList.deleteChannelData(channelId);
    } else {
        for (var i = 0, l = articleChannelDatas.length; i < l; i++) {
            articleChannelData = articleChannelDatas[i];
            if (articleChannelData['uuid'] == articleId) {
                index = i;
                break;
            }
        }
        if (index > 0) {
            articleChannelDatas.splice(index, 1);
            articleData[channelId] = articleChannelDatas;
            this.articleData = articleData;
        }
    }
};
DownloadData.prototype.deleteChannelData = function(channelId) {
    var channelData = this['channelData'];
    delete channelData[channelId];
    this.channelData = channelData;
    var articleData = this['articleData'];
    delete articleData[channelId];
    this.articleData = articleData;
};
DownloadData.prototype.getDataFinished = function(type) {
    if (type == 'article' && prepare == 'article') {
        articleList.init();
    }
    if (type == 'channel' && prepare == 'channel') {
        channelList.init();
    }
};
DownloadData.prototype.downloadProgress = function(received, total, type, articleId) {
    var totalRatio, ratio = parseInt(received / total * 100);
    switch (type) {
        case 'lrc':
        case 'archive':
            if (ratio >= 100) {
                ratio = 30;
            } else {
                ratio = parseInt(ratio / 3);
            }
            break;
        case 'mp3':
            if (ratio >= 100) {
                ratio = 40;
            } else {
                ratio = parseInt(ratio / 4);
            }
            break;
    }

    var ratioData = this.ratioData[articleId];
    if (!ratioData) {
        ratioData = {
            'lrc': 0,
            'archive': 0,
            'mp3': 0
        };
    }
    ratioData[type] = ratio;
    var mp3Ratio = ratioData['mp3'],
        lrcRatio = ratioData['lrc'],
        archiveRatio = ratioData['archive'];
    this.ratioData[articleId] = ratioData;
    totalRatio = mp3Ratio + lrcRatio + archiveRatio;
    if (totalRatio > 100) {
        totalRatio = 100;
    }
    totalRatio = totalRatio + '%';
    articleList.updateDownloadingProgress(totalRatio, articleId);
};
DownloadData.prototype.downloadFinished = function(articleId) {
    articleList.setDownloadFinished(articleId);
}
var downloadData = new DownloadData();

(function init() {
    slideNav.In();

    function adjustNavItem() {
        var level2Height = parseInt($('.sideNav').css('height')) - 150,
            tempHeight = 200 + $('.channelInfo').height(),
            level3Height = parseInt($('.sideNav').css('height')) - tempHeight,
            marginRight = parseInt($('.playPage').css('margin-right')) - 3;
        $('#level2 .navItem, #myChannel .navItem').css({
            'height': level2Height
        });
        $('#level3 .navItem').css({
            'height': level3Height
        });
        $('.rightSide').css({
            'margin-right': marginRight
        });
    }
    adjustNavItem();
    $(window).bind('resize', function() {
        adjustNavItem();
    });
    var channelId = '',
        articleId = '',
        lang = '';
    var location = window.location.href.split('?')[1].split('&');
    var data;
    for (var i = 0, l = location.length; i < l; i++) {
        data = location[i].split('=');
        switch (data[0]) {
            case 'lang':
                lang = data[1];
                break;
            case 'channelId':
                channelId = data[1];
                break;
            case 'articleId':
                articleId = data[1];
                break;
        }
    }
    var titleName;
    switch (lang) {
        case 'en':
        case 'betaen':
        case 'local':
            lang = 'en';
            titleName = '每日英语听力';
            break;
        case 'fr':
        case 'betafr':
            lang = 'fr';
            titleName = '每日法语听力';
            break;
        case 'de':
        case 'betade':
            titleName = '每日德语听力';
            break;
        case 'es':
        case 'betaes':
            titleName = '每日西语听力';
            break;
    }
    $('.logo a').text(titleName);
    $('body').attr('id', lang);
    downloadData.setData('lang', lang);
    if (!channelId && !articleId) {
        prepare = 'channel';
    }
    if (channelId && articleId) {
        prepare = 'article';
        articleList.setData('id', channelId);
        article.setData('id', articleId);
    }
    Qt.pageLoaded();
    $('.gotoOnline').click(function() {
        Qt.gotoOnline();
        WebApi.saveData('downloadState', 'yes');
    });
}());

function setSet(font, theme, translationState, explainState, explainTipState, fontFamily, textAlign) {
    $('body').attr('class', font + ' ' + theme);
    $('body').attr('class', font + ' ' + theme);
    $('.wrap').css({
        'text-align': textAlign,
        'font-family': fontFamily
    });
    if (window.article) {
        article.setLrc(translationState);
        article.setExplain(explainState);
    } else {
        Tools.setLocalStorage('translationState', translationState);
        Tools.setLocalStorage('explainState', explainState);
    }
    switch (explainTipState) {
        case 'highlight':
            if (!$('.article').hasClass('transHighlightSet')) {
                $('.article').addClass('transHighlightSet');
            }
            break;
        case 'explain':
            $('.article').removeClass('transHighlightSet');
            break;
    }
}

function setData(key, value) {
    if (key == 'userInfo') {
        userInfo = JSON.parse(value);
        if (userInfo['lifelong']) {
            articleList.setExportEnable('enable');
        } else {
            articleList.setExportEnable('disable');
        }
    }
}

function setZipDir(dir) {
    zipDir = 'file:///' + dir + '/';
}

function resetZipDir(dir) {
    dir = dir.replace(/file:\/\/\//, '');
    return dir;
}